ColorLUTPalette
Color Processing

Perform image color processing using various types of bit range restricted palette color look up tables. More...

## Functions

NppStatus | nppiLUTPalette_8u_C1R (const Npp8u *pSrc, int nSrcStep, Npp8u *pDst, int nDstStep, NppiSize oSizeROI, const Npp8u *pTable, int nBitSize)
| One channel 8-bit unsigned bit range restricted palette look-up-table color conversion. More...
NppStatus | nppiLUTPalette_8u24u_C1R (const Npp8u *pSrc, int nSrcStep, Npp8u *pDst, int nDstStep, NppiSize oSizeROI, const Npp8u *pTable, int nBitSize)
| One channel 8-bit unsigned bit range restricted 24-bit palette look-up-table color conversion with 24-bit destination output per pixel. More...
NppStatus | nppiLUTPalette_8u32u_C1R (const Npp8u *pSrc, int nSrcStep, Npp32u *pDst, int nDstStep, NppiSize oSizeROI, const Npp32u *pTable, int nBitSize)
| One channel 8-bit unsigned bit range restricted 32-bit palette look-up-table color conversion with 32-bit destination output per pixel. More...
NppStatus | nppiLUTPalette_8u_C3R (const Npp8u *pSrc, int nSrcStep, Npp8u *pDst, int nDstStep, NppiSize oSizeROI, const Npp8u *pTables[3], int nBitSize)
| Three channel 8-bit unsigned bit range restricted palette look-up-table color conversion. More...
NppStatus | nppiLUTPalette_8u_C4R (const Npp8u *pSrc, int nSrcStep, Npp8u *pDst, int nDstStep, NppiSize oSizeROI, const Npp8u *pTables[4], int nBitSize)
| Four channel 8-bit unsigned bit range restricted palette look-up-table color conversion. More...
NppStatus | nppiLUTPalette_8u_AC4R (const Npp8u *pSrc, int nSrcStep, Npp8u *pDst, int nDstStep, NppiSize oSizeROI, const Npp8u *pTables[3], int nBitSize)
| Four channel 8-bit unsigned bit range restricted palette look-up-table color conversion, not affecting Alpha. More...
NppStatus | nppiLUTPalette_16u_C1R (const Npp16u *pSrc, int nSrcStep, Npp16u *pDst, int nDstStep, NppiSize oSizeROI, const Npp16u *pTable, int nBitSize)
| One channel 16-bit unsigned bit range restricted palette look-up-table color conversion. More...
NppStatus | nppiLUTPalette_16u8u_C1R (const Npp16u *pSrc, int nSrcStep, Npp8u *pDst, int nDstStep, NppiSize oSizeROI, const Npp8u *pTable, int nBitSize)
| One channel 16-bit unsigned bit range restricted 8-bit unsigned palette look-up-table color conversion with 8-bit unsigned destination output per pixel. More...
NppStatus | nppiLUTPalette_16u24u_C1R (const Npp16u *pSrc, int nSrcStep, Npp8u *pDst, int nDstStep, NppiSize oSizeROI, const Npp8u *pTable, int nBitSize)
| One channel 16-bit unsigned bit range restricted 24-bit unsigned palette look-up-table color conversion with 24-bit unsigned destination output per pixel. More...
NppStatus | nppiLUTPalette_16u32u_C1R (const Npp16u *pSrc, int nSrcStep, Npp32u *pDst, int nDstStep, NppiSize oSizeROI, const Npp32u *pTable, int nBitSize)
| One channel 16-bit unsigned bit range restricted 32-bit palette look-up-table color conversion with 32-bit unsigned destination output per pixel. More...
NppStatus | nppiLUTPalette_16u_C3R (const Npp16u *pSrc, int nSrcStep, Npp16u *pDst, int nDstStep, NppiSize oSizeROI, const Npp16u *pTables[3], int nBitSize)
| Three channel 16-bit unsigned bit range restricted palette look-up-table color conversion. More...
NppStatus | nppiLUTPalette_16u_C4R (const Npp16u *pSrc, int nSrcStep, Npp16u *pDst, int nDstStep, NppiSize oSizeROI, const Npp16u *pTables[4], int nBitSize)
| Four channel 16-bit unsigned bit range restricted palette look-up-table color conversion. More...
NppStatus | nppiLUTPalette_16u_AC4R (const Npp16u *pSrc, int nSrcStep, Npp16u *pDst, int nDstStep, NppiSize oSizeROI, const Npp16u *pTables[3], int nBitSize)
| Four channel 16-bit unsigned bit range restricted palette look-up-table color conversion, not affecting Alpha. More...
NppStatus | nppiLUTPaletteSwap_8u_C3A0C4R (const Npp8u *pSrc, int nSrcStep, int nAlphaValue, Npp8u *pDst, int nDstStep, NppiSize oSizeROI, const Npp8u *pTables[3], int nBitSize)
| Three channel 8-bit unsigned source bit range restricted palette look-up-table color conversion to four channel 8-bit unsigned destination output with alpha. More...
NppStatus | nppiLUTPaletteSwap_16u_C3A0C4R (const Npp16u *pSrc, int nSrcStep, int nAlphaValue, Npp16u *pDst, int nDstStep, NppiSize oSizeROI, const Npp16u *pTables[3], int nBitSize)
| Three channel 16-bit unsigned source bit range restricted palette look-up-table color conversion to four channel 16-bit unsigned destination output with alpha. More...

## Detailed Description

Perform image color processing using various types of bit range restricted palette color look up tables.

## Function Documentation

NppStatus nppiLUTPalette_16u24u_C1R | ( | const Npp16u * | pSrc,
|  | int | nSrcStep,
|  | Npp8u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp8u * | pTable,
|  | int | nBitSize
| ) |  |

One channel 16-bit unsigned bit range restricted 24-bit unsigned palette look-up-table color conversion with 24-bit unsigned destination output per pixel.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step (3 unsigned bytes per pixel).
  oSizeROI | Region-of-Interest (ROI).
  pTable | Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
  nBitSize | Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.

NppStatus nppiLUTPalette_16u32u_C1R | ( | const Npp16u * | pSrc,
|  | int | nSrcStep,
|  | Npp32u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp32u * | pTable,
|  | int | nBitSize
| ) |  |

One channel 16-bit unsigned bit range restricted 32-bit palette look-up-table color conversion with 32-bit unsigned destination output per pixel.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step (4 bytes per pixel).
  oSizeROI | Region-of-Interest (ROI).
  pTable | Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
  nBitSize | Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.

NppStatus nppiLUTPalette_16u8u_C1R | ( | const Npp16u * | pSrc,
|  | int | nSrcStep,
|  | Npp8u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp8u * | pTable,
|  | int | nBitSize
| ) |  |

One channel 16-bit unsigned bit range restricted 8-bit unsigned palette look-up-table color conversion with 8-bit unsigned destination output per pixel.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step (1 unsigned byte per pixel).
  oSizeROI | Region-of-Interest (ROI).
  pTable | Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
  nBitSize | Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.

NppStatus nppiLUTPalette_16u_AC4R | ( | const Npp16u * | pSrc,
|  | int | nSrcStep,
|  | Npp16u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp16u * | pTables[3],
|  | int | nBitSize
| ) |  |

Four channel 16-bit unsigned bit range restricted palette look-up-table color conversion, not affecting Alpha.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values. Alpha channel is the last channel and is not processed.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step.
  oSizeROI | Region-of-Interest (ROI).
  pTables | Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
  nBitSize | Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.

NppStatus nppiLUTPalette_16u_C1R | ( | const Npp16u * | pSrc,
|  | int | nSrcStep,
|  | Npp16u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp16u * | pTable,
|  | int | nBitSize
| ) |  |

One channel 16-bit unsigned bit range restricted palette look-up-table color conversion.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step.
  oSizeROI | Region-of-Interest (ROI).
  pTable | Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
  nBitSize | Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.

NppStatus nppiLUTPalette_16u_C3R | ( | const Npp16u * | pSrc,
|  | int | nSrcStep,
|  | Npp16u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp16u * | pTables[3],
|  | int | nBitSize
| ) |  |

Three channel 16-bit unsigned bit range restricted palette look-up-table color conversion.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step.
  oSizeROI | Region-of-Interest (ROI).
  pTables | Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
  nBitSize | Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.

NppStatus nppiLUTPalette_16u_C4R | ( | const Npp16u * | pSrc,
|  | int | nSrcStep,
|  | Npp16u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp16u * | pTables[4],
|  | int | nBitSize
| ) |  |

Four channel 16-bit unsigned bit range restricted palette look-up-table color conversion.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step.
  oSizeROI | Region-of-Interest (ROI).
  pTables | Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
  nBitSize | Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.

NppStatus nppiLUTPalette_8u24u_C1R | ( | const Npp8u * | pSrc,
|  | int | nSrcStep,
|  | Npp8u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp8u * | pTable,
|  | int | nBitSize
| ) |  |

One channel 8-bit unsigned bit range restricted 24-bit palette look-up-table color conversion with 24-bit destination output per pixel.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step (3 bytes per pixel).
  oSizeROI | Region-of-Interest (ROI).
  pTable | Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
  nBitSize | Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.

NppStatus nppiLUTPalette_8u32u_C1R | ( | const Npp8u * | pSrc,
|  | int | nSrcStep,
|  | Npp32u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp32u * | pTable,
|  | int | nBitSize
| ) |  |

One channel 8-bit unsigned bit range restricted 32-bit palette look-up-table color conversion with 32-bit destination output per pixel.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step (4 bytes per pixel).
  oSizeROI | Region-of-Interest (ROI).
  pTable | Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
  nBitSize | Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.

NppStatus nppiLUTPalette_8u_AC4R | ( | const Npp8u * | pSrc,
|  | int | nSrcStep,
|  | Npp8u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp8u * | pTables[3],
|  | int | nBitSize
| ) |  |

Four channel 8-bit unsigned bit range restricted palette look-up-table color conversion, not affecting Alpha.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values. Alpha channel is the last channel and is not processed.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step.
  oSizeROI | Region-of-Interest (ROI).
  pTables | Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
  nBitSize | Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.

NppStatus nppiLUTPalette_8u_C1R | ( | const Npp8u * | pSrc,
|  | int | nSrcStep,
|  | Npp8u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp8u * | pTable,
|  | int | nBitSize
| ) |  |

One channel 8-bit unsigned bit range restricted palette look-up-table color conversion.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step.
  oSizeROI | Region-of-Interest (ROI).
  pTable | Pointer to an array of user defined OUTPUT palette values (this is a device memory pointer)
  nBitSize | Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.

NppStatus nppiLUTPalette_8u_C3R | ( | const Npp8u * | pSrc,
|  | int | nSrcStep,
|  | Npp8u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp8u * | pTables[3],
|  | int | nBitSize
| ) |  |

Three channel 8-bit unsigned bit range restricted palette look-up-table color conversion.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step.
  oSizeROI | Region-of-Interest (ROI).
  pTables | Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
  nBitSize | Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.

NppStatus nppiLUTPalette_8u_C4R | ( | const Npp8u * | pSrc,
|  | int | nSrcStep,
|  | Npp8u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp8u * | pTables[4],
|  | int | nBitSize
| ) |  |

Four channel 8-bit unsigned bit range restricted palette look-up-table color conversion.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step.
  oSizeROI | Region-of-Interest (ROI).
  pTables | Host pointer to an array of 4 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values.
  nBitSize | Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.

NppStatus nppiLUTPaletteSwap_16u_C3A0C4R | ( | const Npp16u * | pSrc,
|  | int | nSrcStep,
|  | int | nAlphaValue,
|  | Npp16u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp16u * | pTables[3],
|  | int | nBitSize
| ) |  |

Three channel 16-bit unsigned source bit range restricted palette look-up-table color conversion to four channel 16-bit unsigned destination output with alpha.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values. This function also reverses the source pixel channel order in the destination so the Alpha channel is the first channel.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step (3 unsigned short integers per pixel).
  nAlphaValue | Signed alpha value that will be used to initialize the pixel alpha channel position in all modified destination pixels.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step (4 unsigned short integers per pixel with alpha).
  oSizeROI | Region-of-Interest (ROI).
  pTables | Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values. Alpha values < 0 or > 65535 will cause destination pixel alpha channel values to be unmodified.
  nBitSize | Number of least significant bits (must be > 0 and <= 16) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 16.

NppStatus nppiLUTPaletteSwap_8u_C3A0C4R | ( | const Npp8u * | pSrc,
|  | int | nSrcStep,
|  | int | nAlphaValue,
|  | Npp8u * | pDst,
|  | int | nDstStep,
|  | NppiSize | oSizeROI,
|  | const Npp8u * | pTables[3],
|  | int | nBitSize
| ) |  |

Three channel 8-bit unsigned source bit range restricted palette look-up-table color conversion to four channel 8-bit unsigned destination output with alpha.

The LUT is derived from a set of user defined mapping points in a palette and source pixels are then processed using a restricted bit range when looking up palette values. This function also reverses the source pixel channel order in the destination so the Alpha channel is the first channel.

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step (3 bytes per pixel).
  nAlphaValue | Signed alpha value that will be used to initialize the pixel alpha channel position in all modified destination pixels.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step (4 bytes per pixel with alpha).
  oSizeROI | Region-of-Interest (ROI).
  pTables | Host pointer to an array of 3 device memory pointers, one per color CHANNEL, pointing to user defined OUTPUT palette values. Alpha values < 0 or > 255 will cause destination pixel alpha channel values to be unmodified.
  nBitSize | Number of least significant bits (must be > 0 and <= 8) of each source pixel value to use as index into palette table during conversion.

Returns
  Image Data Related Error Codes, ROI Related Error Codes
  - NPP_LUT_PALETTE_BITSIZE_ERROR if nBitSize is < 1 or > 8.

Copyright © 2009-2017 NVIDIA Corporation